//+------------------------------------------------------------------+
//|                                                +MySiMPLE_ts+.mq4 |
//|                                        Copyright  2009, masemus |
//|                                                masemus@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, masemus"
#property link      "masemus@yahoo.com"

//---- indicator settings
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  Magenta
#property indicator_color2  Aqua
#property indicator_color3  Silver
#property indicator_color4  LimeGreen
#property indicator_color5  Blue
#property indicator_color6  Red
#property indicator_color7  Lime
#property indicator_color8  Gold
//---- 
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 1
#property indicator_width4 4
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 0
#property indicator_width8 0
//---- 
extern bool candleTiME = true;
extern int cTiME_clr = Black;
//---- 
double SMMA55[],SMMA34[],pSAR[],SMMA14[];
double TrendUP[],TrendDN[],SignalUP[],SignalDN[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(8);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(4,108);
   SetIndexArrow(5,108);
   SetIndexArrow(6,108);
   SetIndexArrow(7,108);
//---- 4 indicator buffers mapping
   SetIndexBuffer(0,SMMA55);
   SetIndexBuffer(1,SMMA34);
   SetIndexBuffer(2,pSAR);
   SetIndexBuffer(3,SMMA14);
   SetIndexBuffer(4,TrendUP);
   SetIndexBuffer(5,TrendDN);
   SetIndexBuffer(6,SignalUP);
   SetIndexBuffer(7,SignalDN);
//---- initialization done
   return(0);
  }
//
int deinit()
{
   ObjectDelete("cTiME");
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,limit;
   int counted_bars=IndicatorCounted();
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   //---- 
   for(i=0; i<limit; i++)
     {
      double jGX10=iMA(NULL,0,4,0,MODE_SMMA,PRICE_MEDIAN,i)-iMA(NULL,0,6,0,MODE_SMMA,PRICE_MEDIAN,i);
      double jGX11=iMA(NULL,0,4,0,MODE_SMMA,PRICE_MEDIAN,i+1)-iMA(NULL,0,6,0,MODE_SMMA,PRICE_MEDIAN,i+1);
      double jGX20=(iMA(NULL,0,4,0,MODE_SMMA,PRICE_MEDIAN,i)-iMA(NULL,0,6,0,MODE_SMMA,PRICE_MEDIAN,i))
                   -iMAOnArray(jGX10,Bars,2,0,MODE_SMMA,i);
      double jGX21=(iMA(NULL,0,4,0,MODE_SMMA,PRICE_MEDIAN,i+1)-iMA(NULL,0,6,0,MODE_SMMA,PRICE_MEDIAN,i+1))
                   -iMAOnArray(jGX10,Bars,2,0,MODE_SMMA,i+1);
   //---- SMMA_55 :: Median
         SMMA55[i]=iMA(NULL,0,55,0,MODE_SMMA,PRICE_MEDIAN,i);
   //---- SMMA_34 :: Median
         SMMA34[i]=iMA(NULL,0,34,0,MODE_SMMA,PRICE_MEDIAN,i);
   //---- pSAR ::
         pSAR[i]=iSAR(NULL,0,0.02,0.2,i);
   //---- fireWALL :: Barry
         SMMA14[i]=iMA(NULL,0,14,0,MODE_SMMA,PRICE_MEDIAN,i);
   //---- Trend_UP :: Signal_UP
      if((jGX10>0&&0>jGX11)||(jGX20>0&&0>jGX21))
        {
         TrendUP[i]=pSAR[i];
        }
      else
        {
         TrendUP[i]=EMPTY_VALUE;
        }
   //---- Trend_DN :: Signal_DN
      if((jGX10<0&&0<jGX11)||(jGX20<0&&0<jGX21))
        {
         TrendDN[i]=pSAR[i];
        }
      else
        {
         TrendDN[i]=EMPTY_VALUE;
        }
   //---- Continue_UP ::
      if(jGX10>jGX11&&jGX20>jGX21)
        {
         SignalUP[i]=pSAR[i];
        }
      else
        {
         SignalUP[i]=EMPTY_VALUE;
        }
   //---- Continue_DN ::
      if(jGX10<jGX11&&jGX20<jGX21)
        {
         SignalDN[i]=pSAR[i];
        }
      else
        {
         SignalDN[i]=EMPTY_VALUE;
        }
     }
   //---- Candle_Time ::
   if(candleTiME == true) {
   string Teks="", T_Menit, T_Detik;
   double d_A, d_B;

   d_B = (Time[4]-Time[5])-MathMod(CurTime(),Time[4]-Time[5]);
   d_A = d_B/60;
   d_B = (d_A-MathFloor(d_A))*60;
   d_A = MathFloor(d_A);
   T_Menit = DoubleToStr(d_A,0);
   T_Detik = DoubleToStr(d_B,0);
   Teks=T_Menit+":"+T_Detik;
//----
   ObjectDelete("cTiME");
   //
   if(ObjectFind("cTiME") != 0)
   {
   ObjectCreate("cTiME", OBJ_TEXT, 0, Time[0], Close[0]+ 0.0005);
   ObjectSetText("cTiME", "                 < "+Teks, 11, "Trebucet Bold", cTiME_clr);
   }
   else
   {
   ObjectMove("cTiME", 0, Time[0], Close[0]+0.0005);
   }
     }
   //---- done
   return(0);
  }
//+------------------------------------------------------------------+

